Index: src/includes/classes/Smarty/sysplugins/smarty_internal_templateparser.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_templateparser.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_templateparser.php	(revision )
@@ -4428,7 +2702,7 @@
                 $x->stateno = $yyact;
                 $x->major = $yygoto;
                 $x->minor = $yy_lefthand_side;
-                $this->yystack[$this->yyidx] = $x;
+                $this->yystack[ $this->yyidx ] = $x;
             } else {
                 $this->yy_shift($yyact, $yygoto, $yy_lefthand_side);
             }
@@ -4449,12 +2723,11 @@
 
     public function yy_syntax_error($yymajor, $TOKEN)
     {
-        #line 75 "smarty_internal_templateparser.y"
+        #line 207 "../smarty/lexer/smarty_internal_templateparser.y"
 
         $this->internalError = true;
         $this->yymajor = $yymajor;
         $this->compiler->trigger_template_error();
-        #line 3142 "smarty_internal_templateparser.php"
     }
 
     public function yy_accept()
@@ -4463,16 +2736,13 @@
             fprintf($this->yyTraceFILE, "%sAccept!\n", $this->yyTracePrompt);
         }
         while ($this->yyidx >= 0) {
-            $stack = $this->yy_pop_parser_stack();
+            $this->yy_pop_parser_stack();
         }
-        #line 66 "smarty_internal_templateparser.y"
+        #line 200 "../smarty/lexer/smarty_internal_templateparser.y"
 
         $this->successful = !$this->internalError;
         $this->internalError = false;
         $this->retvalue = $this->_retvalue;
-        //echo $this->retvalue."\n\n";
-
-        #line 3160 "smarty_internal_templateparser.php"
     }
 
     public function doParse($yymajor, $yytokenvalue)
@@ -4486,20 +2756,17 @@
             $x->stateno = 0;
             $x->major = 0;
             $this->yystack = array();
-            array_push($this->yystack, $x);
+            $this->yystack[] = $x;
         }
         $yyendofinput = ($yymajor == 0);
 
         if ($this->yyTraceFILE) {
-            fprintf($this->yyTraceFILE, "%sInput %s\n",
-                    $this->yyTracePrompt, $this->yyTokenName[$yymajor]);
+            fprintf($this->yyTraceFILE, "%sInput %s\n", $this->yyTracePrompt, $this->yyTokenName[ $yymajor ]);
         }
 
         do {
             $yyact = $this->yy_find_shift_action($yymajor);
-            if ($yymajor < self::YYERRORSYMBOL &&
-                !$this->yy_is_expected_token($yymajor)
-            ) {
+            if ($yymajor < self::YYERRORSYMBOL && !$this->yy_is_expected_token($yymajor)) {
                 // force a syntax error
                 $yyact = self::YY_ERROR_ACTION;
             }
@@ -4515,26 +2782,23 @@
                 $this->yy_reduce($yyact - self::YYNSTATE);
             } elseif ($yyact == self::YY_ERROR_ACTION) {
                 if ($this->yyTraceFILE) {
-                    fprintf($this->yyTraceFILE, "%sSyntax Error!\n",
-                            $this->yyTracePrompt);
+                    fprintf($this->yyTraceFILE, "%sSyntax Error!\n", $this->yyTracePrompt);
                 }
                 if (self::YYERRORSYMBOL) {
                     if ($this->yyerrcnt < 0) {
                         $this->yy_syntax_error($yymajor, $yytokenvalue);
                     }
-                    $yymx = $this->yystack[$this->yyidx]->major;
+                    $yymx = $this->yystack[ $this->yyidx ]->major;
                     if ($yymx == self::YYERRORSYMBOL || $yyerrorhit) {
                         if ($this->yyTraceFILE) {
-                            fprintf($this->yyTraceFILE, "%sDiscard input token %s\n",
-                                    $this->yyTracePrompt, $this->yyTokenName[$yymajor]);
+                            fprintf($this->yyTraceFILE, "%sDiscard input token %s\n", $this->yyTracePrompt,
+                                    $this->yyTokenName[ $yymajor ]);
                         }
                         $this->yy_destructor($yymajor, $yytokenvalue);
                         $yymajor = self::YYNOCODE;
                     } else {
-                        while ($this->yyidx >= 0 &&
-                            $yymx != self::YYERRORSYMBOL &&
-                            ($yyact = $this->yy_find_shift_action(self::YYERRORSYMBOL)) >= self::YYNSTATE
-                        ) {
+                        while ($this->yyidx >= 0 && $yymx != self::YYERRORSYMBOL &&
+                            ($yyact = $this->yy_find_shift_action(self::YYERRORSYMBOL)) >= self::YYNSTATE) {
                             $this->yy_pop_parser_stack();
                         }
                         if ($this->yyidx < 0 || $yymajor == 0) {
@@ -4566,3 +2830,4 @@
         } while ($yymajor != self::YYNOCODE && $this->yyidx >= 0);
     }
 }
+
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_parsetree_text.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_parsetree_text.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_parsetree_text.php	(revision )
@@ -0,0 +1,40 @@
+<?php
+
+/**
+ * Smarty Internal Plugin Templateparser Parse Tree
+ * These are classes to build parse tree in the template parser
+ *
+ * @package    Smarty
+ * @subpackage Compiler
+ * @author     Thue Kristensen
+ * @author     Uwe Tews
+ *             *
+ *             template text
+ * @package    Smarty
+ * @subpackage Compiler
+ * @ignore
+ */
+class Smarty_Internal_ParseTree_Text extends Smarty_Internal_ParseTree
+{
+    /**
+     * Create template text buffer
+     *
+     * @param string $data text
+     */
+    public function __construct($data)
+    {
+        $this->data = $data;
+    }
+
+    /**
+     * Return buffer content
+     *
+     * @param \Smarty_Internal_Templateparser $parser
+     *
+     * @return string text
+     */
+    public function to_smarty_php(Smarty_Internal_Templateparser $parser)
+    {
+        return $this->data;
+    }
+}
Index: src/includes/classes/Smarty/plugins/modifiercompiler.count_paragraphs.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/modifiercompiler.count_paragraphs.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/modifiercompiler.count_paragraphs.php	(revision )
@@ -1,0 +1,0 @@
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_cacheresource_file.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_cacheresource_file.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_cacheresource_file.php	(revision )
@@ -29,14 +29,12 @@
     {
         $_source_file_path = str_replace(':', '.', $_template->source->filepath);
         $_cache_id = isset($_template->cache_id) ? preg_replace('![^\w\|]+!', '_', $_template->cache_id) : null;
-        $_compile_id = isset($_template->compile_id) ? preg_replace('![^\w\|]+!', '_', $_template->compile_id) : null;
+        $_compile_id = isset($_template->compile_id) ? preg_replace('![^\w]+!', '_', $_template->compile_id) : null;
         $_filepath = $_template->source->uid;
         // if use_sub_dirs, break file into directories
         if ($_template->smarty->use_sub_dirs) {
-            $_filepath = substr($_filepath, 0, 2) . DS
-                . substr($_filepath, 2, 2) . DS
-                . substr($_filepath, 4, 2) . DS
-                . $_filepath;
+            $_filepath = substr($_filepath, 0, 2) . DS . substr($_filepath, 2, 2) . DS . substr($_filepath, 4, 2) . DS .
+                $_filepath;
         }
         $_compile_dir_sep = $_template->smarty->use_sub_dirs ? DS : '^';
         if (isset($_cache_id)) {
@@ -60,10 +58,13 @@
             }
             $cached->lock_id = $_lock_dir . sha1($_cache_id . $_compile_id . $_template->source->uid) . '.lock';
         }
-        $cached->filepath = $_cache_dir . $_cache_id . $_compile_id . $_filepath . '.' . basename($_source_file_path) . '.php';
-        $cached->timestamp = @filemtime($cached->filepath);
-        $cached->exists = !!$cached->timestamp;
+        $cached->filepath = $_cache_dir . $_cache_id . $_compile_id . $_filepath . '.' . basename($_source_file_path) .
+            '.php';
+        $cached->timestamp = $cached->exists = is_file($cached->filepath);
+        if ($cached->exists) {
+            $cached->timestamp = filemtime($cached->filepath);
-    }
+        }
+    }
 
     /**
      * populate Cached Object with timestamp and exists from Resource
@@ -74,27 +75,34 @@
      */
     public function populateTimestamp(Smarty_Template_Cached $cached)
     {
-        $cached->timestamp = @filemtime($cached->filepath);
-        $cached->exists = !!$cached->timestamp;
+        $cached->timestamp = $cached->exists = is_file($cached->filepath);
+        if ($cached->exists) {
+            $cached->timestamp = filemtime($cached->filepath);
-    }
+        }
+    }
 
     /**
      * Read the cached template and process its header
      *
      * @param Smarty_Internal_Template $_template template object
      * @param Smarty_Template_Cached   $cached    cached object
+     * @param bool                     $update flag if called because cache update
      *
-     * @return booleantrue or false if the cached content does not exist
+     * @return boolean true or false if the cached content does not exist
      */
-    public function process(Smarty_Internal_Template $_template, Smarty_Template_Cached $cached = null)
+    public function process(Smarty_Internal_Template $_template, Smarty_Template_Cached $cached = null, $update = false)
     {
         /** @var Smarty_Internal_Template $_smarty_tpl
          * used in included file
          */
         $_smarty_tpl = $_template;
-
+        $_template->cached->valid = false;
+        if ($update && defined('HHVM_VERSION')) {
+            return $_template->smarty->ext->_hhvm->includeHhvm($_template, $_template->cached->filepath);
+        } else {
-        return @include $_template->cached->filepath;
-    }
+            return @include $_template->cached->filepath;
+        }
+    }
 
     /**
      * Write the rendered template output to cache
@@ -106,14 +114,32 @@
      */
     public function writeCachedContent(Smarty_Internal_Template $_template, $content)
     {
-        if (Smarty_Internal_Write_File::writeFile($_template->cached->filepath, $content, $_template->smarty) === true) {
-            $_template->cached->timestamp = @filemtime($_template->cached->filepath);
-            $_template->cached->exists = !!$_template->cached->timestamp;
-            if ($_template->cached->exists) {
+        if ($_template->smarty->ext->_writeFile->writeFile($_template->cached->filepath, $content, $_template->smarty) === true) {
+            if (function_exists('opcache_invalidate')) {
+                opcache_invalidate($_template->cached->filepath);
+            }
+            $cached = $_template->cached;
+            $cached->timestamp = $cached->exists = is_file($cached->filepath);
+            if ($cached->exists) {
+                $cached->timestamp = filemtime($cached->filepath);
                 return true;
             }
         }
+        return false;
+    }
 
+    /**
+     * Read cached template from cache
+     *
+     * @param  Smarty_Internal_Template $_template template object
+     *
+     * @return string  content
+     */
+    public function readCachedContent(Smarty_Internal_Template $_template)
+    {
+        if (is_file($_template->cached->filepath)) {
+            return file_get_contents($_template->cached->filepath);
+        }
         return false;
     }
 
@@ -127,7 +153,7 @@
      */
     public function clearAll(Smarty $smarty, $exp_time = null)
     {
-        return $this->clear($smarty, null, null, null, $exp_time);
+        return Smarty_Internal_Extension_Clear::clear($smarty, null, null, null, $exp_time);
     }
 
     /**
@@ -143,110 +169,9 @@
      */
     public function clear(Smarty $smarty, $resource_name, $cache_id, $compile_id, $exp_time)
     {
-        $_cache_id = isset($cache_id) ? preg_replace('![^\w\|]+!', '_', $cache_id) : null;
-        $_compile_id = isset($compile_id) ? preg_replace('![^\w\|]+!', '_', $compile_id) : null;
-        $_dir_sep = $smarty->use_sub_dirs ? '/' : '^';
-        $_compile_id_offset = $smarty->use_sub_dirs ? 3 : 0;
-        if (($_dir = realpath($smarty->getCacheDir())) === false) {
-            return 0;
+        return Smarty_Internal_Extension_Clear::clear($smarty, $resource_name, $cache_id, $compile_id, $exp_time);
-        }
+    }
-        $_dir .= '/';
-        $_dir_length = strlen($_dir);
-        if (isset($_cache_id)) {
-            $_cache_id_parts = explode('|', $_cache_id);
-            $_cache_id_parts_count = count($_cache_id_parts);
-            if ($smarty->use_sub_dirs) {
-                foreach ($_cache_id_parts as $id_part) {
-                    $_dir .= $id_part . DS;
-                }
-            }
-        }
-        if (isset($resource_name)) {
-            $_save_stat = $smarty->caching;
-            $smarty->caching = true;
-            $tpl = new $smarty->template_class($resource_name, $smarty);
-            $smarty->caching = $_save_stat;
 
-            // remove from template cache
-            $tpl->source; // have the template registered before unset()
-            if ($smarty->allow_ambiguous_resources) {
-                $_templateId = $tpl->source->unique_resource . $tpl->cache_id . $tpl->compile_id;
-            } else {
-                $_templateId = $smarty->joined_template_dir . '#' . $resource_name . $tpl->cache_id . $tpl->compile_id;
-            }
-            if (isset($_templateId[150])) {
-                $_templateId = sha1($_templateId);
-            }
-            unset($smarty->template_objects[$_templateId]);
-
-            if ($tpl->source->exists) {
-                $_resourcename_parts = basename(str_replace('^', '/', $tpl->cached->filepath));
-            } else {
-                return 0;
-            }
-        }
-        $_count = 0;
-        $_time = time();
-        if (file_exists($_dir)) {
-            $_cacheDirs = new RecursiveDirectoryIterator($_dir);
-            $_cache = new RecursiveIteratorIterator($_cacheDirs, RecursiveIteratorIterator::CHILD_FIRST);
-            foreach ($_cache as $_file) {
-                if (substr(basename($_file->getPathname()), 0, 1) == '.' || strpos($_file, '.svn') !== false) {
-                    continue;
-                }
-                // directory ?
-                if ($_file->isDir()) {
-                    if (!$_cache->isDot()) {
-                        // delete folder if empty
-                        @rmdir($_file->getPathname());
-                    }
-                } else {
-                    $_parts = explode($_dir_sep, str_replace('\\', '/', substr((string) $_file, $_dir_length)));
-                    $_parts_count = count($_parts);
-                    // check name
-                    if (isset($resource_name)) {
-                        if ($_parts[$_parts_count - 1] != $_resourcename_parts) {
-                            continue;
-                        }
-                    }
-                    // check compile id
-                    if (isset($_compile_id) && (!isset($_parts[$_parts_count - 2 - $_compile_id_offset]) || $_parts[$_parts_count - 2 - $_compile_id_offset] != $_compile_id)) {
-                        continue;
-                    }
-                    // check cache id
-                    if (isset($_cache_id)) {
-                        // count of cache id parts
-                        $_parts_count = (isset($_compile_id)) ? $_parts_count - 2 - $_compile_id_offset : $_parts_count - 1 - $_compile_id_offset;
-                        if ($_parts_count < $_cache_id_parts_count) {
-                            continue;
-                        }
-                        for ($i = 0; $i < $_cache_id_parts_count; $i ++) {
-                            if ($_parts[$i] != $_cache_id_parts[$i]) {
-                                continue 2;
-                            }
-                        }
-                    }
-                    // expired ?
-                    if (isset($exp_time)) {
-                        if ($exp_time < 0) {
-                            preg_match('#\'cache_lifetime\' =>\s*(\d*)#', file_get_contents($_file), $match);
-                            if ($_time < (@filemtime($_file) + $match[1])) {
-                                continue;
-                            }
-                        } else {
-                            if ($_time - @filemtime($_file) < $exp_time) {
-                                continue;
-                            }
-                        }
-                    }
-                    $_count += @unlink((string) $_file) ? 1 : 0;
-                }
-            }
-        }
-
-        return $_count;
-    }
-
     /**
      * Check is cache is locked for this template
      *
@@ -262,9 +187,12 @@
         } else {
             clearstatcache();
         }
+        if (is_file($cached->lock_id)) {
-        $t = @filemtime($cached->lock_id);
+            $t = @filemtime($cached->lock_id);
-
-        return $t && (time() - $t < $smarty->locking_timeout);
+            return $t && (time() - $t < $smarty->locking_timeout);
+        } else {
+            return false;
+        }
     }
 
     /**
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_insert.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_insert.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_insert.php	(revision )
@@ -24,6 +24,7 @@
      * @see Smarty_Internal_CompileBase
      */
     public $required_attributes = array('name');
+
     /**
      * Attribute definition: Overwrites base class.
      *
@@ -31,6 +32,7 @@
      * @see Smarty_Internal_CompileBase
      */
     public $shorttag_order = array('name');
+
     /**
      * Attribute definition: Overwrites base class.
      *
@@ -42,17 +44,21 @@
     /**
      * Compiles code for the {insert} tag
      *
-     * @param  array  $args     array with attributes from parser
+     * @param  array                                $args     array with attributes from parser
-     * @param  object $compiler compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler compiler object
      *
      * @return string compiled code
+     * @throws \SmartyCompilerException
      */
-    public function compile($args, $compiler)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler)
     {
         // check and get attributes
         $_attr = $this->getAttributes($compiler, $args);
-        // never compile as nocache code
+        $nocacheParam = $compiler->template->caching && ($compiler->tag_nocache || $compiler->nocache);
+        if (!$nocacheParam) {
+            // do not compile as nocache code
-        $compiler->suppressNocacheProcessing = true;
+            $compiler->suppressNocacheProcessing = true;
+        }
         $compiler->tag_nocache = true;
         $_smarty_tpl = $compiler->template;
         $_name = null;
@@ -60,19 +66,24 @@
 
         $_output = '<?php ';
         // save possible attributes
-        eval('$_name = ' . $_attr['name'] . ';');
+        eval('$_name = @' . $_attr['name'] . ';');
         if (isset($_attr['assign'])) {
             // output will be stored in a smarty variable instead of being displayed
             $_assign = $_attr['assign'];
             // create variable to make sure that the compiler knows about its nocache status
-            $compiler->template->tpl_vars[trim($_attr['assign'], "'")] = new Smarty_Variable(null, true);
+            $var = trim($_attr['assign'], "'");
+            if (isset($compiler->template->tpl_vars[$var])) {
+                $compiler->template->tpl_vars[$var]->nocache = true;
+            } else {
+                $compiler->template->tpl_vars[$var] = new Smarty_Variable(null, true);
-        }
+            }
+        }
         if (isset($_attr['script'])) {
             // script which must be included
             $_function = "smarty_insert_{$_name}";
             $_smarty_tpl = $compiler->template;
             $_filepath = false;
-            eval('$_script = ' . $_attr['script'] . ';');
+            eval('$_script = @' . $_attr['script'] . ';');
             if (!isset($compiler->smarty->security_policy) && file_exists($_script)) {
                 $_filepath = $_script;
             } else {
@@ -92,13 +103,13 @@
                 }
             }
             if ($_filepath == false) {
-                $compiler->trigger_template_error("{insert} missing script file '{$_script}'", $compiler->lex->taglineno);
+                $compiler->trigger_template_error("{insert} missing script file '{$_script}'", null, true);
             }
             // code for script file loading
             $_output .= "require_once '{$_filepath}' ;";
             require_once $_filepath;
             if (!is_callable($_function)) {
-                $compiler->trigger_template_error(" {insert} function '{$_function}' is not callable in script file '{$_script}'", $compiler->lex->taglineno);
+                $compiler->trigger_template_error(" {insert} function '{$_function}' is not callable in script file '{$_script}'", null, true);
             }
         } else {
             $_filepath = 'null';
@@ -107,7 +118,7 @@
             if (!is_callable($_function)) {
                 // try plugin
                 if (!$_function = $compiler->getPlugin($_name, 'insert')) {
-                    $compiler->trigger_template_error("{insert} no function or plugin found for '{$_name}'", $compiler->lex->taglineno);
+                    $compiler->trigger_template_error("{insert} no function or plugin found for '{$_name}'", null, true);
                 }
             }
         }
@@ -121,14 +132,14 @@
         $_params = 'array(' . implode(", ", $_paramsArray) . ')';
         // call insert
         if (isset($_assign)) {
-            if ($_smarty_tpl->caching) {
+            if ($_smarty_tpl->caching && !$nocacheParam) {
                 $_output .= "echo Smarty_Internal_Nocache_Insert::compile ('{$_function}',{$_params}, \$_smarty_tpl, '{$_filepath}',{$_assign});?>";
             } else {
                 $_output .= "\$_smarty_tpl->assign({$_assign} , {$_function} ({$_params},\$_smarty_tpl), true);?>";
             }
         } else {
             $compiler->has_output = true;
-            if ($_smarty_tpl->caching) {
+            if ($_smarty_tpl->caching && !$nocacheParam) {
                 $_output .= "echo Smarty_Internal_Nocache_Insert::compile ('{$_function}',{$_params}, \$_smarty_tpl, '{$_filepath}');?>";
             } else {
                 $_output .= "echo {$_function}({$_params},\$_smarty_tpl);?>";
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_nocache.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_nocache.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_nocache.php	(revision )
@@ -17,20 +17,25 @@
 class Smarty_Internal_Compile_Nocache extends Smarty_Internal_CompileBase
 {
     /**
+     * Array of names of valid option flags
+     *
+     * @var array
+     */
+    public $option_flags = array();
+
+    /**
      * Compiles code for the {nocache} tag
      * This tag does not generate compiled output. It only sets a compiler flag.
      *
-     * @param  array  $args     array with attributes from parser
+     * @param  array                                $args     array with attributes from parser
-     * @param  object $compiler compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler compiler object
      *
      * @return bool
      */
-    public function compile($args, $compiler)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler)
     {
         $_attr = $this->getAttributes($compiler, $args);
-        if ($_attr['nocache'] === true) {
-            $compiler->trigger_template_error('nocache option not allowed', $compiler->lex->taglineno);
-        }
+        $this->openTag($compiler, 'nocache', array($compiler->nocache));
         // enter nocache mode
         $compiler->nocache = true;
         // this tag does not return compiled code
@@ -52,16 +57,16 @@
      * Compiles code for the {/nocache} tag
      * This tag does not generate compiled output. It only sets a compiler flag.
      *
-     * @param  array  $args     array with attributes from parser
+     * @param  array                                $args     array with attributes from parser
-     * @param  object $compiler compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler compiler object
      *
      * @return bool
      */
-    public function compile($args, $compiler)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler)
     {
         $_attr = $this->getAttributes($compiler, $args);
         // leave nocache mode
-        $compiler->nocache = false;
+        list($compiler->nocache) = $this->closeTag($compiler, array('nocache'));
         // this tag does not return compiled code
         $compiler->has_code = false;
 
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_var.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_var.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_var.php	(revision )
@@ -0,0 +1,33 @@
+<?php
+
+/**
+ * Runtime Methods createLocalArrayVariable
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ *
+ **/
+class Smarty_Internal_Runtime_Var
+{
+    /**
+     * Template code runtime function to create a local Smarty variable for array assignments
+     *
+     * @param \Smarty_Internal_Template $tpl     template object
+     * @param string                    $varName template variable name
+     * @param bool                      $nocache cache mode of variable
+     */
+    public function createLocalArrayVariable(Smarty_Internal_Template $tpl, $varName, $nocache = false)
+    {
+        if (!isset($tpl->tpl_vars[$varName])) {
+            $tpl->tpl_vars[$varName] = new Smarty_Variable(array(), $nocache);
+        } else {
+            $tpl->tpl_vars[$varName] = clone $tpl->tpl_vars[$varName];
+            if (!(is_array($tpl->tpl_vars[$varName]->value) ||
+                $tpl->tpl_vars[$varName]->value instanceof ArrayAccess)
+            ) {
+                settype($tpl->tpl_vars[$varName]->value, 'array');
+            }
+        }
+    }
+}
Index: src/includes/classes/Smarty/plugins/function.html_select_time.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/function.html_select_time.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/function.html_select_time.php	(revision )
@@ -1,0 +1,0 @@
Index: src/includes/classes/Smarty/plugins/modifiercompiler.count_sentences.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/modifiercompiler.count_sentences.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/modifiercompiler.count_sentences.php	(revision )
@@ -1,0 +1,0 @@
